#!/bin/sh
. `dirname $0`/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param



echo "================================================================================="
echo "starting gstreamer with GRAY Source ..."
echo "read $FRAME_SIZE, write to file bw_$CAMERA.raw"
echo "================================================================================="
echo ""
echo "configure CSI camnera port with media_control"
echo "============================================="

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'0->"csi":0[1]'
media-ctl -l "'csi':1->'csi capture':0[1]"
#           Camera -> CSI -> CSI capture (/dev/videoX)

media-ctl -V ''$CAM_ENTITY_NUMBER'0 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES' ('$OFFSET_SENSOR')/'$SENSOR_RES']'
media-ctl -V '"csi":1 [fmt:'$CAM_BW_FMT'/'$SENSOR_RES']'


echo ""
echo " configure camera with v4l2_control"
echo " =================================="

$V4L2_CTRL_CAM0


echo ""
echo "start gstreamer, break with ctl-C"
echo "================================="

gst-launch-1.0 \
	v4l2src num-buffers=$NUMBER_OF_PIC device=$CAM_DEVICE $NORM ! \
	video/x-raw,format=GRAY8,depth=8$FRAME_SIZE ! \
	multifilesink location=bw_$CAMERA.raw

echo "File \"bw_$CAMERA.raw\" (Y8$FRAME_SIZE)"