#!/bin/sh
#check bootarg in config-file

GST_PATH="/usr/share/phytec-gstreamer-examples"
. $GST_PATH/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

# Additional Settings
COL_FMT="SGRBG8"
X_RES=${SENSOR_RES%%x*}
Y_RES=${SENSOR_RES##*x}
REG_SET_FILE=$GST_PATH/${REG_SET_FILE##*/}

echo ""
echo "configure CSI camnera port with media_control"
echo "============================================="

media-ctl -r
media-ctl -l ''$CAM_ENTITY_NUMBER'0->"csi":0[1]'
media-ctl -l "'csi':1->'csi capture':0[1]"
#           Camera -> CSI -> CSI capture (/dev/videoX)

media-ctl -V ''$CAM_ENTITY_NUMBER'0 [fmt:'$CAM_COL_FMT'/'$SENSOR_RES' ('$OFFSET_SENSOR')/'$SENSOR_RES']'
media-ctl -V '"csi":1 [fmt:'$CAM_COL_FMT'/'$SENSOR_RES']'


echo ""
echo " configure camera with v4l2_control"
echo " =================================="

$V4L2_CTRL_CAM0


echo "starting save_raw_image with format $COL_FMT"
echo "read $X_RES x $Y_RES and write to file $CAMERA"_"$COL_FMT"_"x.raw"
echo "================================================================"

#save_raw_image -D $CAM_DEVICE -no_subdev -f $COL_FMT -res_x $X_RES -res_y $Y_RES -d $NUMBER_OF_PIC -n $CAMERA"_"$COL_FMT"_"
yavta $CAM_DEVICE -c8 --skip 7 -f$COL_FMT -F$CAMERA"_M_PixDepth_"$CAM_COL_FMT".raw"